<script setup lang="ts">
import { reactive, onMounted, toRaw } from 'vue';
import { PageContainer } from 'antdv-pro-layout';
import { ProModal } from 'antdv-pro-modal';
import { SizeType } from 'ant-design-vue/es/config-provider';
import { MenuInfo } from 'ant-design-vue/es/menu/src/interface';
import { ColumnsType } from 'ant-design-vue/es/table';
import { Form, Modal, message } from 'ant-design-vue/es';
import { parseDateToStr } from '@/utils/date-utils';
import { RESULT_CODE_SUCCESS } from '@/constants/result-constants';
import {
  addNeHostCmd,
  delNeHostCmd,
  getNeHostCmd,
  listNeHostCmd,
  updateNeHostCmd,
} from '@/api/ne/neHostCmd';
import useDictStore from '@/store/modules/dict';
import useI18n from '@/hooks/useI18n';
const { getDict } = useDictStore();
const { t } = useI18n();

/**字典数据 */
let dict: {
  /**分组 */
  neHostCmdGroupId: DictType[];
} = reactive({
  neHostCmdGroupId: [],
});

/**查询参数 */
let queryParams = reactive({
  /**命令类型 */
  cmdType: '',
  /**分组 */
  groupId: undefined,
  /**名称 */
  title: '',
  /**当前页数 */
  pageNum: 1,
  /**每页条数 */
  pageSize: 20,
});

/**查询参数重置 */
function fnQueryReset() {
  queryParams = Object.assign(queryParams, {
    hostType: '',
    groupId: undefined,
    title: '',
    pageNum: 1,
    pageSize: 20,
  });
  tablePagination.current = 1;
  tablePagination.pageSize = 20;
  fnGetList();
}

/**表格状态类型 */
type TabeStateType = {
  /**加载等待 */
  loading: boolean;
  /**紧凑型 */
  size: SizeType;
  /**搜索栏 */
  seached: boolean;
  /**记录数据 */
  data: object[];
};

/**表格状态 */
let tableState: TabeStateType = reactive({
  loading: false,
  size: 'middle',
  seached: false,
  data: [],
});

/**表格字段列 */
let tableColumns: ColumnsType = [
  {
    title: t('common.rowId'),
    dataIndex: 'cmdId',
    align: 'center',
    width: 50,
  },
  {
    title: t('views.ne.neHostCmd.cmdType'),
    dataIndex: 'cmdType',
    align: 'left',
    width: 100,
  },
  {
    title: t('views.ne.neHostCmd.groupId'),
    dataIndex: 'groupId',
    key: 'groupId',
    align: 'left',
    width: 100,
  },
  {
    title: t('views.ne.neHostCmd.title'),
    dataIndex: 'title',
    align: 'left',
    width: 100,
  },
  {
    title: t('common.createTime'),
    dataIndex: 'createTime',
    align: 'left',
    width: 150,
    customRender(opt) {
      if (!opt.value) return '';
      return parseDateToStr(opt.value);
    },
  },
  {
    title: t('common.operate'),
    key: 'cmdId',
    align: 'left',
  },
];

/**表格分页器参数 */
let tablePagination = reactive({
  /**当前页数 */
  current: 1,
  /**每页条数 */
  pageSize: 20,
  /**默认的每页条数 */
  defaultPageSize: 20,
  /**指定每页可以显示多少条 */
  pageSizeOptions: ['10', '20', '50', '100'],
  /**只有一页时是否隐藏分页器 */
  hideOnSinglePage: false,
  /**是否可以快速跳转至某页 */
  showQuickJumper: true,
  /**是否可以改变 pageSize */
  showSizeChanger: true,
  /**数据总数 */
  total: 0,
  showTotal: (total: number) => t('common.tablePaginationTotal', { total }),
  onChange: (page: number, pageSize: number) => {
    tablePagination.current = page;
    tablePagination.pageSize = pageSize;
    queryParams.pageNum = page;
    queryParams.pageSize = pageSize;
    fnGetList();
  },
});

/**表格紧凑型变更操作 */
function fnTableSize({ key }: MenuInfo) {
  tableState.size = key as SizeType;
}

/**查询备份信息列表, pageNum初始页数 */
function fnGetList(pageNum?: number) {
  if (tableState.loading) return;
  tableState.loading = true;
  if (pageNum) {
    queryParams.pageNum = pageNum;
  }
  listNeHostCmd(toRaw(queryParams)).then(res => {
     if (res.code === RESULT_CODE_SUCCESS) {
      const { total, rows } = res.data;
      tablePagination.total = total;
      tableState.data = rows;
      if (
        tablePagination.total <=
          (queryParams.pageNum - 1) * tablePagination.pageSize &&
        queryParams.pageNum !== 1
      ) {
        tableState.loading = false;
        fnGetList(queryParams.pageNum - 1);
      }
    }
    tableState.loading = false;
  });
}

/**对话框对象信息状态类型 */
type ModalStateType = {
  /**新增框或修改框是否显示 */
  openByEdit: boolean;
  /**标题 */
  title: string;
  /**表单数据 */
  from: Record<string, any>;
  /**确定按钮 loading */
  confirmLoading: boolean;
};

/**对话框对象信息状态 */
let modalState: ModalStateType = reactive({
  openByEdit: false,
  title: '信息',
  from: {
    cmdId: undefined,
    cmdType: '',
    groupId: '0',
    title: '',
    command: '',
    remark: '',
  },
  confirmLoading: false,
});

/**对话框内表单属性和校验规则 */
const modalStateFrom = Form.useForm(
  modalState.from,
  reactive({
    title: [
      {
        required: true,
        min: 1,
        max: 50,
        message: t('views.ne.neHostCmd.titlePlease'),
      },
    ],
    command: [
      {
        required: true,
        min: 1,
        max: 50,
        message: t('views.ne.neHostCmd.commandPlease'),
      },
    ],
  })
);

/**
 * 对话框弹出显示为 新增或者修改
 * @param roleId 角色编号ID, 不传为新增
 */
function fnModalVisibleByEdit(roleId?: string | number) {
  if (!roleId) {
    modalStateFrom.resetFields();
    modalState.title = t('views.ne.neHostCmd.addTitle');
    modalState.openByEdit = true;
  } else {
    if (modalState.confirmLoading) return;
    const hide = message.loading(t('common.loading'), 0);
    modalState.confirmLoading = true;
    // 查询角色详细同时根据角色ID查询菜单下拉树结构
    getNeHostCmd(roleId).then(res => {
      modalState.confirmLoading = false;
      hide();
      if (res.code === RESULT_CODE_SUCCESS && res.data) {
        modalState.from = Object.assign(modalState.from, res.data);
        modalState.title = t('views.ne.neHostCmd.editTitle');
        modalState.openByEdit = true;
      } else {
        message.error(t('common.getInfoFail'), 2);
      }
    });
  }
}

/**
 * 对话框弹出确认执行函数
 * 进行表达规则校验
 */
function fnModalOk() {
  modalStateFrom
    .validate()
    .then(() => {
      modalState.confirmLoading = true;
      const from = toRaw(modalState.from);
      const neHost = from.cmdId ? updateNeHostCmd(from) : addNeHostCmd(from);
      const hide = message.loading(t('common.loading'), 0);
      neHost
        .then(res => {
          if (res.code === RESULT_CODE_SUCCESS) {
            message.success({
              content: t('common.operateOk'),
              duration: 2,
            });
            fnModalCancel();
            fnGetList(1);
          } else {
            message.error({
              content: `${res.msg}`,
              duration: 2,
            });
          }
        })
        .finally(() => {
          modalState.confirmLoading = false;
          hide();
        });
    })
    .catch(e => {
      message.error(t('common.errorFields', { num: e.errorFields.length }), 3);
    });
}

/**
 * 对话框弹出关闭执行函数
 * 进行表达规则校验
 */
function fnModalCancel() {
  modalState.openByEdit = false;
  modalStateFrom.resetFields();
}

/**
 * 网元主机删除
 * @param cmdId 网元主机编号ID
 */
function fnRecordDelete(cmdId: string) {
  Modal.confirm({
    title: t('common.tipTitle'),
    content: t('views.ne.neHostCmd.delTip', { num: cmdId }),
    onOk() {
      const hide = message.loading(t('common.loading'), 0);
      delNeHostCmd(cmdId).then(res => {
        hide();
        if (res.code === RESULT_CODE_SUCCESS) {
          message.success({
            content: t('common.operateOk'),
            duration: 2,
          });
          fnGetList();
        } else {
          message.error({
            content: `${res.msg}`,
            duration: 2,
          });
        }
      });
    },
  });
}

onMounted(() => {
  // 初始字典数据
  Promise.allSettled([getDict('ne_host_cmd_groupId')]).then(resArr => {
    if (resArr[0].status === 'fulfilled') {
      dict.neHostCmdGroupId = resArr[0].value;
    }
  });
  // 获取列表数据
  fnGetList();
});
</script>

<template>
  <PageContainer>
    <a-card
      v-show="tableState.seached"
      :bordered="false"
      :body-style="{ marginBottom: '24px', paddingBottom: 0 }"
    >
      <!-- 表格搜索栏 -->
      <a-form :model="queryParams" name="queryParams" layout="horizontal">
        <a-row :gutter="16">
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item
              :label="t('views.ne.neHostCmd.cmdType')"
              name="cmdType"
            >
              <a-input
                v-model:value="queryParams.cmdType"
                :allow-clear="true"
                :placeholder="t('common.inputPlease')"
              ></a-input>
            </a-form-item>
          </a-col>
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item
              :label="t('views.ne.neHostCmd.groupId')"
              name="groupId"
            >
              <a-select
                v-model:value="queryParams.groupId"
                allow-clear
                :placeholder="t('common.selectPlease')"
                :options="dict.neHostCmdGroupId"
              >
              </a-select>
            </a-form-item>
          </a-col>
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item :label="t('views.ne.neHostCmd.title')" name="title">
              <a-input
                v-model:value="queryParams.title"
                :allow-clear="true"
                :placeholder="t('common.inputPlease')"
              ></a-input>
            </a-form-item>
          </a-col>
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item>
              <a-space :size="8">
                <a-button type="primary" @click.prevent="fnGetList(1)">
                  <template #icon><SearchOutlined /></template>
                  {{ t('common.search') }}
                </a-button>
                <a-button type="default" @click.prevent="fnQueryReset">
                  <template #icon><ClearOutlined /></template>
                  {{ t('common.reset') }}
                </a-button>
              </a-space>
            </a-form-item>
          </a-col>
        </a-row>
      </a-form>
    </a-card>

    <a-card :bordered="false" :body-style="{ padding: '0px' }">
      <!-- 插槽-卡片左侧侧 -->
      <template #title>
        <a-button type="primary" @click.prevent="fnModalVisibleByEdit()">
          <template #icon><PlusOutlined /></template>
          {{ t('common.addText') }}
        </a-button>
      </template>

      <!-- 插槽-卡片右侧 -->
      <template #extra>
        <a-space :size="8" align="center">
          <a-tooltip>
            <template #title>{{ t('common.searchBarText') }}</template>
            <a-switch
              v-model:checked="tableState.seached"
              :checked-children="t('common.switch.show')"
              :un-checked-children="t('common.switch.hide')"
              size="small"
            />
          </a-tooltip>
          <a-tooltip>
            <template #title>{{ t('common.reloadText') }}</template>
            <a-button type="text" @click.prevent="fnGetList()">
              <template #icon><ReloadOutlined /></template>
            </a-button>
          </a-tooltip>
          <a-tooltip>
            <template #title>{{ t('common.sizeText') }}</template>
            <a-dropdown trigger="click" placement="bottomRight">
              <a-button type="text">
                <template #icon><ColumnHeightOutlined /></template>
              </a-button>
              <template #overlay>
                <a-menu
                  :selected-keys="[tableState.size as string]"
                  @click="fnTableSize"
                >
                  <a-menu-item key="default">
                    {{ t('common.size.default') }}
                  </a-menu-item>
                  <a-menu-item key="middle">
                    {{ t('common.size.middle') }}
                  </a-menu-item>
                  <a-menu-item key="small">
                    {{ t('common.size.small') }}
                  </a-menu-item>
                </a-menu>
              </template>
            </a-dropdown>
          </a-tooltip>
        </a-space>
      </template>

      <!-- 表格列表 -->
      <a-table
        class="table"
        row-key="cmdId"
        :columns="tableColumns"
        :loading="tableState.loading"
        :data-source="tableState.data"
        :size="tableState.size"
        :pagination="tablePagination"
        :scroll="{ x: tableColumns.length * 120 }"
      >
        <template #bodyCell="{ column, record }">
          <template v-if="column.key === 'cmdId'">
            <a-space :size="8" align="center">
              <a-tooltip>
                <template #title>{{ t('common.editText') }}</template>
                <a-button
                  type="link"
                  @click.prevent="fnModalVisibleByEdit(record.cmdId)"
                >
                  <template #icon><FormOutlined /></template>
                </a-button>
              </a-tooltip>
              <a-tooltip>
                <template #title>{{ t('common.deleteText') }}</template>
                <a-button
                  type="link"
                  @click.prevent="fnRecordDelete(record.cmdId)"
                >
                  <template #icon><DeleteOutlined /></template>
                </a-button>
              </a-tooltip>
            </a-space>
          </template>
        </template>
      </a-table>

      <!-- 新增框或修改框 -->
      <ProModal
        :drag="true"
        :width="800"
        :destroyOnClose="true"
        :keyboard="false"
        :mask-closable="false"
        :open="modalState.openByEdit"
        :title="modalState.title"
        :confirm-loading="modalState.confirmLoading"
        @ok="fnModalOk"
        @cancel="fnModalCancel"
      >
        <a-form
          name="modalStateFromByEdit"
          layout="horizontal"
          :label-col="{ span: 6 }"
          :label-wrap="true"
        >
          <a-row>
            <a-col :lg="12" :md="12" :xs="24">
              <a-form-item
                :label="t('views.ne.neHostCmd.cmdType')"
                name="cmdType"
              >
                <a-input
                  v-model:value="modalState.from.cmdType"
                  allow-clear
                  :maxlength="50"
                >
                </a-input>
              </a-form-item>
            </a-col>
            <a-col :lg="12" :md="12" :xs="24">
              <a-form-item
                :label="t('views.ne.neHostCmd.groupId')"
                name="groupId"
              >
                <a-select
                  v-model:value="modalState.from.groupId"
                  default-value="0"
                  :options="dict.neHostCmdGroupId"
                >
                </a-select>
              </a-form-item>
            </a-col>
          </a-row>

          <a-form-item
            :label="t('views.ne.neHostCmd.title')"
            name="title"
            v-bind="modalStateFrom.validateInfos.title"
            :label-col="{ span: 3 }"
            :label-wrap="true"
          >
            <a-input
              v-model:value="modalState.from.title"
              allow-clear
              :maxlength="50"
            >
            </a-input>
          </a-form-item>

          <a-form-item
            :label="t('views.ne.neHostCmd.command')"
            name="command"
            :label-col="{ span: 3 }"
            :label-wrap="true"
          >
            <a-textarea
              v-model:value="modalState.from.command"
              :auto-size="{ minRows: 4, maxRows: 6 }"
              :maxlength="500"
              :show-count="true"
            />
          </a-form-item>

          <a-form-item
            :label="t('common.remark')"
            name="remark"
            :label-col="{ span: 3 }"
            :label-wrap="true"
          >
            <a-textarea
              v-model:value="modalState.from.remark"
              :auto-size="{ minRows: 4, maxRows: 6 }"
              :maxlength="450"
              :show-count="true"
              :placeholder="t('common.inputPlease')"
            />
          </a-form-item>
        </a-form>
      </ProModal>
    </a-card>
  </PageContainer>
</template>

<style lang="less" scoped>
.table :deep(.ant-pagination) {
  padding: 0 24px;
}
</style>
